var gulp = require('gulp');
var util = require('../shark-util');
var path = require('path');


/**
 * baseConfig:  基本配置
 * browserSyncConf:  browserSync的配置
 * cb: browserSync回调函数
 */
var sharkBrowerSync = function(appConfig) {
    var baseConf = appConfig.baseConf;
    var browserSyncConf = appConfig.browserSync || {};
    gulp.task('browser-sync', ['sass-preprocess'], function(cb) {
        gulp.watch(path.join(baseConf.rootPath, '.tmp/step1', baseConf.cssPath, '**/*.css'), ['sass-preprocess']);
        gulp.watch([path.join(baseConf.rootPath, baseConf.webapp, '**/*.html'),
            path.join(baseConf.rootPath, baseConf.webapp, '**/*.ftl'),
            path.join(baseConf.rootPath, baseConf.webapp, baseConf.imgPath, '**/*.*')
        ], function() {
            util.reload();
        });
        return util.browserSync.init({
            proxy: baseConf.hostname + ":" + baseConf.port,
            port: browserSyncConf.port || 9000,
            open: false,
            logLevel: browserSyncConf.logLevel || "info",
            logPrefix: baseConf.product || "My Awesome Project"
        }, cb());
    });
};
module.exports = sharkBrowerSync;